import { ATN } from "antlr4ts/atn/ATN";
import { CharStream } from "antlr4ts/CharStream";
import { Lexer } from "antlr4ts/Lexer";
import { Vocabulary } from "antlr4ts/Vocabulary";
export declare class ExpressionLexer extends Lexer {
    static readonly T__0 = 1;
    static readonly WS = 2;
    static readonly TRUE = 3;
    static readonly FALSE = 4;
    static readonly AND = 5;
    static readonly OR = 6;
    static readonly XOR = 7;
    static readonly IN = 8;
    static readonly IS = 9;
    static readonly BETWEEN = 10;
    static readonly LIKE = 11;
    static readonly MATCHES = 12;
    static readonly NULL_LITERAL = 13;
    static readonly DOT = 14;
    static readonly AT = 15;
    static readonly BACKTICK = 16;
    static readonly BACKSLASH = 17;
    static readonly PIPE = 18;
    static readonly BANG = 19;
    static readonly QMARK = 20;
    static readonly DOLLAR = 21;
    static readonly POUND = 22;
    static readonly LPAREN = 23;
    static readonly RPAREN = 24;
    static readonly LBRACKET = 25;
    static readonly RBRACKET = 26;
    static readonly LCURLY = 27;
    static readonly RCURLY = 28;
    static readonly COMMA = 29;
    static readonly SEMI = 30;
    static readonly COLON = 31;
    static readonly ASSIGN = 32;
    static readonly DEFAULT = 33;
    static readonly PLUS = 34;
    static readonly MINUS = 35;
    static readonly DIV = 36;
    static readonly STAR = 37;
    static readonly MOD = 38;
    static readonly POWER = 39;
    static readonly EQUAL = 40;
    static readonly NOT_EQUAL = 41;
    static readonly LESS_THAN = 42;
    static readonly LESS_THAN_OR_EQUAL = 43;
    static readonly GREATER_THAN = 44;
    static readonly GREATER_THAN_OR_EQUAL = 45;
    static readonly PROJECT = 46;
    static readonly SELECT = 47;
    static readonly SELECT_FIRST = 48;
    static readonly SELECT_LAST = 49;
    static readonly TYPE = 50;
    static readonly LAMBDA = 51;
    static readonly DOT_ESCAPED = 52;
    static readonly QUOTE = 53;
    static readonly STRING_LITERAL = 54;
    static readonly APOS = 55;
    static readonly ID = 56;
    static readonly REAL_LITERAL = 57;
    static readonly INTEGER_LITERAL = 58;
    static readonly HEXADECIMAL_INTEGER_LITERAL = 59;
    static readonly DECIMAL_DIGIT = 60;
    static readonly INTEGER_TYPE_SUFFIX = 61;
    static readonly HEX_DIGIT = 62;
    static readonly EXPONENT_PART = 63;
    static readonly SIGN = 64;
    static readonly REAL_TYPE_SUFFIX = 65;
    static readonly channelNames: string[];
    static readonly modeNames: string[];
    static readonly ruleNames: string[];
    private static readonly _LITERAL_NAMES;
    private static readonly _SYMBOLIC_NAMES;
    static readonly VOCABULARY: Vocabulary;
    readonly vocabulary: Vocabulary;
    constructor(input: CharStream);
    readonly grammarFileName: string;
    readonly ruleNames: string[];
    readonly serializedATN: string;
    readonly channelNames: string[];
    readonly modeNames: string[];
    static readonly _serializedATN: string;
    static __ATN: ATN;
    static readonly _ATN: ATN;
}
