// Generated from ../Expression.g4 by ANTLR 4.7.3-SNAPSHOT


import { ATN } from "antlr4ts/atn/ATN";
import { ATNDeserializer } from "antlr4ts/atn/ATNDeserializer";
import { CharStream } from "antlr4ts/CharStream";
import { Lexer } from "antlr4ts/Lexer";
import { LexerATNSimulator } from "antlr4ts/atn/LexerATNSimulator";
import { NotNull } from "antlr4ts/Decorators";
import { Override } from "antlr4ts/Decorators";
import { RuleContext } from "antlr4ts/RuleContext";
import { Vocabulary } from "antlr4ts/Vocabulary";
import { VocabularyImpl } from "antlr4ts/VocabularyImpl";

import * as Utils from "antlr4ts/misc/Utils";


export class ExpressionLexer extends Lexer {
	public static readonly T__0 = 1;
	public static readonly WS = 2;
	public static readonly TRUE = 3;
	public static readonly FALSE = 4;
	public static readonly AND = 5;
	public static readonly OR = 6;
	public static readonly XOR = 7;
	public static readonly IN = 8;
	public static readonly IS = 9;
	public static readonly BETWEEN = 10;
	public static readonly LIKE = 11;
	public static readonly MATCHES = 12;
	public static readonly NULL_LITERAL = 13;
	public static readonly DOT = 14;
	public static readonly AT = 15;
	public static readonly BACKTICK = 16;
	public static readonly BACKSLASH = 17;
	public static readonly PIPE = 18;
	public static readonly BANG = 19;
	public static readonly QMARK = 20;
	public static readonly DOLLAR = 21;
	public static readonly POUND = 22;
	public static readonly LPAREN = 23;
	public static readonly RPAREN = 24;
	public static readonly LBRACKET = 25;
	public static readonly RBRACKET = 26;
	public static readonly LCURLY = 27;
	public static readonly RCURLY = 28;
	public static readonly COMMA = 29;
	public static readonly SEMI = 30;
	public static readonly COLON = 31;
	public static readonly ASSIGN = 32;
	public static readonly DEFAULT = 33;
	public static readonly PLUS = 34;
	public static readonly MINUS = 35;
	public static readonly DIV = 36;
	public static readonly STAR = 37;
	public static readonly MOD = 38;
	public static readonly POWER = 39;
	public static readonly EQUAL = 40;
	public static readonly NOT_EQUAL = 41;
	public static readonly LESS_THAN = 42;
	public static readonly LESS_THAN_OR_EQUAL = 43;
	public static readonly GREATER_THAN = 44;
	public static readonly GREATER_THAN_OR_EQUAL = 45;
	public static readonly PROJECT = 46;
	public static readonly SELECT = 47;
	public static readonly SELECT_FIRST = 48;
	public static readonly SELECT_LAST = 49;
	public static readonly TYPE = 50;
	public static readonly LAMBDA = 51;
	public static readonly DOT_ESCAPED = 52;
	public static readonly QUOTE = 53;
	public static readonly STRING_LITERAL = 54;
	public static readonly APOS = 55;
	public static readonly ID = 56;
	public static readonly REAL_LITERAL = 57;
	public static readonly INTEGER_LITERAL = 58;
	public static readonly HEXADECIMAL_INTEGER_LITERAL = 59;
	public static readonly DECIMAL_DIGIT = 60;
	public static readonly INTEGER_TYPE_SUFFIX = 61;
	public static readonly HEX_DIGIT = 62;
	public static readonly EXPONENT_PART = 63;
	public static readonly SIGN = 64;
	public static readonly REAL_TYPE_SUFFIX = 65;

	// tslint:disable:no-trailing-whitespace
	public static readonly channelNames: string[] = [
		"DEFAULT_TOKEN_CHANNEL", "HIDDEN",
	];

	// tslint:disable:no-trailing-whitespace
	public static readonly modeNames: string[] = [
		"DEFAULT_MODE",
	];

	public static readonly ruleNames: string[] = [
		"T__0", "WS", "TRUE", "FALSE", "AND", "OR", "XOR", "IN", "IS", "BETWEEN", 
		"LIKE", "MATCHES", "NULL_LITERAL", "DOT", "AT", "BACKTICK", "BACKSLASH", 
		"PIPE", "BANG", "QMARK", "DOLLAR", "POUND", "LPAREN", "RPAREN", "LBRACKET", 
		"RBRACKET", "LCURLY", "RCURLY", "COMMA", "SEMI", "COLON", "ASSIGN", "DEFAULT", 
		"PLUS", "MINUS", "DIV", "STAR", "MOD", "POWER", "EQUAL", "NOT_EQUAL", 
		"LESS_THAN", "LESS_THAN_OR_EQUAL", "GREATER_THAN", "GREATER_THAN_OR_EQUAL", 
		"PROJECT", "SELECT", "SELECT_FIRST", "SELECT_LAST", "TYPE", "LAMBDA", 
		"DOT_ESCAPED", "QUOTE", "STRING_LITERAL", "APOS", "ID", "REAL_LITERAL", 
		"INTEGER_LITERAL", "HEXADECIMAL_INTEGER_LITERAL", "DECIMAL_DIGIT", "INTEGER_TYPE_SUFFIX", 
		"HEX_DIGIT", "EXPONENT_PART", "SIGN", "REAL_TYPE_SUFFIX",
	];

	private static readonly _LITERAL_NAMES: Array<string | undefined> = [
		undefined, "'new'", undefined, "'true'", "'false'", "'and'", "'or'", "'xor'", 
		"'in'", "'is'", "'between'", "'like'", "'matches'", "'null'", "'.'", "'@'", 
		"'`'", "'\\'", "'|'", "'!'", "'?'", "'$'", "'#'", "'('", "')'", "'['", 
		"']'", "'{'", "'}'", "','", "';'", "':'", "'='", "'??'", "'+'", "'-'", 
		"'/'", "'*'", "'%'", "'^'", "'=='", "'!='", "'<'", "'<='", "'>'", "'>='", 
		"'!{'", "'?{'", "'^{'", "'${'", "'T('", "'{|'", "'\\'", "'''",
	];
	private static readonly _SYMBOLIC_NAMES: Array<string | undefined> = [
		undefined, undefined, "WS", "TRUE", "FALSE", "AND", "OR", "XOR", "IN", 
		"IS", "BETWEEN", "LIKE", "MATCHES", "NULL_LITERAL", "DOT", "AT", "BACKTICK", 
		"BACKSLASH", "PIPE", "BANG", "QMARK", "DOLLAR", "POUND", "LPAREN", "RPAREN", 
		"LBRACKET", "RBRACKET", "LCURLY", "RCURLY", "COMMA", "SEMI", "COLON", 
		"ASSIGN", "DEFAULT", "PLUS", "MINUS", "DIV", "STAR", "MOD", "POWER", "EQUAL", 
		"NOT_EQUAL", "LESS_THAN", "LESS_THAN_OR_EQUAL", "GREATER_THAN", "GREATER_THAN_OR_EQUAL", 
		"PROJECT", "SELECT", "SELECT_FIRST", "SELECT_LAST", "TYPE", "LAMBDA", 
		"DOT_ESCAPED", "QUOTE", "STRING_LITERAL", "APOS", "ID", "REAL_LITERAL", 
		"INTEGER_LITERAL", "HEXADECIMAL_INTEGER_LITERAL", "DECIMAL_DIGIT", "INTEGER_TYPE_SUFFIX", 
		"HEX_DIGIT", "EXPONENT_PART", "SIGN", "REAL_TYPE_SUFFIX",
	];
	public static readonly VOCABULARY: Vocabulary = new VocabularyImpl(ExpressionLexer._LITERAL_NAMES, ExpressionLexer._SYMBOLIC_NAMES, []);

	// @Override
	// @NotNull
	public get vocabulary(): Vocabulary {
		return ExpressionLexer.VOCABULARY;
	}
	// tslint:enable:no-trailing-whitespace


	constructor(input: CharStream) {
		super(input);
		this._interp = new LexerATNSimulator(ExpressionLexer._ATN, this);
	}

	// @Override
	public get grammarFileName(): string { return "Expression.g4"; }

	// @Override
	public get ruleNames(): string[] { return ExpressionLexer.ruleNames; }

	// @Override
	public get serializedATN(): string { return ExpressionLexer._serializedATN; }

	// @Override
	public get channelNames(): string[] { return ExpressionLexer.channelNames; }

	// @Override
	public get modeNames(): string[] { return ExpressionLexer.modeNames; }

	public static readonly _serializedATN: string =
		"\x03\uC91D\uCABA\u058D\uAFBA\u4F53\u0607\uEA8B\uC241\x02C\u01AA\b\x01" +
		"\x04\x02\t\x02\x04\x03\t\x03\x04\x04\t\x04\x04\x05\t\x05\x04\x06\t\x06" +
		"\x04\x07\t\x07\x04\b\t\b\x04\t\t\t\x04\n\t\n\x04\v\t\v\x04\f\t\f\x04\r" +
		"\t\r\x04\x0E\t\x0E\x04\x0F\t\x0F\x04\x10\t\x10\x04\x11\t\x11\x04\x12\t" +
		"\x12\x04\x13\t\x13\x04\x14\t\x14\x04\x15\t\x15\x04\x16\t\x16\x04\x17\t" +
		"\x17\x04\x18\t\x18\x04\x19\t\x19\x04\x1A\t\x1A\x04\x1B\t\x1B\x04\x1C\t" +
		"\x1C\x04\x1D\t\x1D\x04\x1E\t\x1E\x04\x1F\t\x1F\x04 \t \x04!\t!\x04\"\t" +
		"\"\x04#\t#\x04$\t$\x04%\t%\x04&\t&\x04\'\t\'\x04(\t(\x04)\t)\x04*\t*\x04" +
		"+\t+\x04,\t,\x04-\t-\x04.\t.\x04/\t/\x040\t0\x041\t1\x042\t2\x043\t3\x04" +
		"4\t4\x045\t5\x046\t6\x047\t7\x048\t8\x049\t9\x04:\t:\x04;\t;\x04<\t<\x04" +
		"=\t=\x04>\t>\x04?\t?\x04@\t@\x04A\tA\x04B\tB\x03\x02\x03\x02\x03\x02\x03" +
		"\x02\x03\x03\x03\x03\x03\x03\x03\x03\x03\x04\x03\x04\x03\x04\x03\x04\x03" +
		"\x04\x03\x05\x03\x05\x03\x05\x03\x05\x03\x05\x03\x05\x03\x06\x03\x06\x03" +
		"\x06\x03\x06\x03\x07\x03\x07\x03\x07\x03\b\x03\b\x03\b\x03\b\x03\t\x03" +
		"\t\x03\t\x03\n\x03\n\x03\n\x03\v\x03\v\x03\v\x03\v\x03\v\x03\v\x03\v\x03" +
		"\v\x03\f\x03\f\x03\f\x03\f\x03\f\x03\r\x03\r\x03\r\x03\r\x03\r\x03\r\x03" +
		"\r\x03\r\x03\x0E\x03\x0E\x03\x0E\x03\x0E\x03\x0E\x03\x0F\x03\x0F\x03\x10" +
		"\x03\x10\x03\x11\x03\x11\x03\x12\x03\x12\x03\x13\x03\x13\x03\x14\x03\x14" +
		"\x03\x15\x03\x15\x03\x16\x03\x16\x03\x17\x03\x17\x03\x18\x03\x18\x03\x19" +
		"\x03\x19\x03\x1A\x03\x1A\x03\x1B\x03\x1B\x03\x1C\x03\x1C\x03\x1D\x03\x1D" +
		"\x03\x1E\x03\x1E\x03\x1F\x03\x1F\x03 \x03 \x03!\x03!\x03\"\x03\"\x03\"" +
		"\x03#\x03#\x03$\x03$\x03%\x03%\x03&\x03&\x03\'\x03\'\x03(\x03(\x03)\x03" +
		")\x03)\x03*\x03*\x03*\x03+\x03+\x03,\x03,\x03,\x03-\x03-\x03.\x03.\x03" +
		".\x03/\x03/\x03/\x030\x030\x030\x031\x031\x031\x032\x032\x032\x033\x03" +
		"3\x033\x034\x034\x034\x035\x035\x035\x036\x036\x037\x037\x037\x077\u0123" +
		"\n7\f7\x0E7\u0126\v7\x037\x037\x038\x038\x038\x039\x039\x079\u012F\n9" +
		"\f9\x0E9\u0132\v9\x03:\x03:\x06:\u0136\n:\r:\x0E:\u0137\x03:\x05:\u013B" +
		"\n:\x03:\x05:\u013E\n:\x03:\x06:\u0141\n:\r:\x0E:\u0142\x03:\x03:\x06" +
		":\u0147\n:\r:\x0E:\u0148\x03:\x05:\u014C\n:\x03:\x05:\u014F\n:\x03:\x06" +
		":\u0152\n:\r:\x0E:\u0153\x03:\x03:\x05:\u0158\n:\x03:\x06:\u015B\n:\r" +
		":\x0E:\u015C\x03:\x03:\x05:\u0161\n:\x03;\x06;\u0164\n;\r;\x0E;\u0165" +
		"\x03;\x05;\u0169\n;\x03<\x03<\x03<\x03<\x06<\u016F\n<\r<\x0E<\u0170\x03" +
		"<\x05<\u0174\n<\x03=\x03=\x03>\x03>\x03>\x03>\x03>\x03>\x03>\x03>\x03" +
		">\x03>\x03>\x03>\x03>\x03>\x03>\x03>\x03>\x05>\u0189\n>\x03?\x03?\x03" +
		"@\x03@\x07@\u018F\n@\f@\x0E@\u0192\v@\x03@\x06@\u0195\n@\r@\x0E@\u0196" +
		"\x03@\x03@\x07@\u019B\n@\f@\x0E@\u019E\v@\x03@\x06@\u01A1\n@\r@\x0E@\u01A2" +
		"\x05@\u01A5\n@\x03A\x03A\x03B\x03B\x02\x02\x02C\x03\x02\x03\x05\x02\x04" +
		"\x07\x02\x05\t\x02\x06\v\x02\x07\r\x02\b\x0F\x02\t\x11\x02\n\x13\x02\v" +
		"\x15\x02\f\x17\x02\r\x19\x02\x0E\x1B\x02\x0F\x1D\x02\x10\x1F\x02\x11!" +
		"\x02\x12#\x02\x13%\x02\x14\'\x02\x15)\x02\x16+\x02\x17-\x02\x18/\x02\x19" +
		"1\x02\x1A3\x02\x1B5\x02\x1C7\x02\x1D9\x02\x1E;\x02\x1F=\x02 ?\x02!A\x02" +
		"\"C\x02#E\x02$G\x02%I\x02&K\x02\'M\x02(O\x02)Q\x02*S\x02+U\x02,W\x02-" +
		"Y\x02.[\x02/]\x020_\x021a\x022c\x023e\x024g\x025i\x026k\x027m\x028o\x02" +
		"9q\x02:s\x02;u\x02<w\x02=y\x02>{\x02?}\x02@\x7F\x02A\x81\x02B\x83\x02" +
		"C\x03\x02\n\x05\x02\v\f\x0F\x0F\"\"\x03\x02))\x05\x02C\\aac|\x06\x022" +
		";C\\aac|\x06\x02NNWWnnww\x05\x022;CHch\x04\x02--//\b\x02FFHHOOffhhoo\x02" +
		"\u01CA\x02\x03\x03\x02\x02\x02\x02\x05\x03\x02\x02\x02\x02\x07\x03\x02" +
		"\x02\x02\x02\t\x03\x02\x02\x02\x02\v\x03\x02\x02\x02\x02\r\x03\x02\x02" +
		"\x02\x02\x0F\x03\x02\x02\x02\x02\x11\x03\x02\x02\x02\x02\x13\x03\x02\x02" +
		"\x02\x02\x15\x03\x02\x02\x02\x02\x17\x03\x02\x02\x02\x02\x19\x03\x02\x02" +
		"\x02\x02\x1B\x03\x02\x02\x02\x02\x1D\x03\x02\x02\x02\x02\x1F\x03\x02\x02" +
		"\x02\x02!\x03\x02\x02\x02\x02#\x03\x02\x02\x02\x02%\x03\x02\x02\x02\x02" +
		"\'\x03\x02\x02\x02\x02)\x03\x02\x02\x02\x02+\x03\x02\x02\x02\x02-\x03" +
		"\x02\x02\x02\x02/\x03\x02\x02\x02\x021\x03\x02\x02\x02\x023\x03\x02\x02" +
		"\x02\x025\x03\x02\x02\x02\x027\x03\x02\x02\x02\x029\x03\x02\x02\x02\x02" +
		";\x03\x02\x02\x02\x02=\x03\x02\x02\x02\x02?\x03\x02\x02\x02\x02A\x03\x02" +
		"\x02\x02\x02C\x03\x02\x02\x02\x02E\x03\x02\x02\x02\x02G\x03\x02\x02\x02" +
		"\x02I\x03\x02\x02\x02\x02K\x03\x02\x02\x02\x02M\x03\x02\x02\x02\x02O\x03" +
		"\x02\x02\x02\x02Q\x03\x02\x02\x02\x02S\x03\x02\x02\x02\x02U\x03\x02\x02" +
		"\x02\x02W\x03\x02\x02\x02\x02Y\x03\x02\x02\x02\x02[\x03\x02\x02\x02\x02" +
		"]\x03\x02\x02\x02\x02_\x03\x02\x02\x02\x02a\x03\x02\x02\x02\x02c\x03\x02" +
		"\x02\x02\x02e\x03\x02\x02\x02\x02g\x03\x02\x02\x02\x02i\x03\x02\x02\x02" +
		"\x02k\x03\x02\x02\x02\x02m\x03\x02\x02\x02\x02o\x03\x02\x02\x02\x02q\x03" +
		"\x02\x02\x02\x02s\x03\x02\x02\x02\x02u\x03\x02\x02\x02\x02w\x03\x02\x02" +
		"\x02\x02y\x03\x02\x02\x02\x02{\x03\x02\x02\x02\x02}\x03\x02\x02\x02\x02" +
		"\x7F\x03\x02\x02\x02\x02\x81\x03\x02\x02\x02\x02\x83\x03\x02\x02\x02\x03" +
		"\x85\x03\x02\x02\x02\x05\x89\x03\x02\x02\x02\x07\x8D\x03\x02\x02\x02\t" +
		"\x92\x03\x02\x02\x02\v\x98\x03\x02\x02\x02\r\x9C\x03\x02\x02\x02\x0F\x9F" +
		"\x03\x02\x02\x02\x11\xA3\x03\x02\x02\x02\x13\xA6\x03\x02\x02\x02\x15\xA9" +
		"\x03\x02\x02\x02\x17\xB1\x03\x02\x02\x02\x19\xB6\x03\x02\x02\x02\x1B\xBE" +
		"\x03\x02\x02\x02\x1D\xC3\x03\x02\x02\x02\x1F\xC5\x03\x02\x02\x02!\xC7" +
		"\x03\x02\x02\x02#\xC9\x03\x02\x02\x02%\xCB\x03\x02\x02\x02\'\xCD\x03\x02" +
		"\x02\x02)\xCF\x03\x02\x02\x02+\xD1\x03\x02\x02\x02-\xD3\x03\x02\x02\x02" +
		"/\xD5\x03\x02\x02\x021\xD7\x03\x02\x02\x023\xD9\x03\x02\x02\x025\xDB\x03" +
		"\x02\x02\x027\xDD\x03\x02\x02\x029\xDF\x03\x02\x02\x02;\xE1\x03\x02\x02" +
		"\x02=\xE3\x03\x02\x02\x02?\xE5\x03\x02\x02\x02A\xE7\x03\x02\x02\x02C\xE9" +
		"\x03\x02\x02\x02E\xEC\x03\x02\x02\x02G\xEE\x03\x02\x02\x02I\xF0\x03\x02" +
		"\x02\x02K\xF2\x03\x02\x02\x02M\xF4\x03\x02\x02\x02O\xF6\x03\x02\x02\x02" +
		"Q\xF8\x03\x02\x02\x02S\xFB\x03\x02\x02\x02U\xFE\x03\x02\x02\x02W\u0100" +
		"\x03\x02\x02\x02Y\u0103\x03\x02\x02\x02[\u0105\x03\x02\x02\x02]\u0108" +
		"\x03\x02\x02\x02_\u010B\x03\x02\x02\x02a\u010E\x03\x02\x02\x02c\u0111" +
		"\x03\x02\x02\x02e\u0114\x03\x02\x02\x02g\u0117\x03\x02\x02\x02i\u011A" +
		"\x03\x02\x02\x02k\u011D\x03\x02\x02\x02m\u011F\x03\x02\x02\x02o\u0129" +
		"\x03\x02\x02\x02q\u012C\x03\x02\x02\x02s\u0160\x03\x02\x02\x02u\u0163" +
		"\x03\x02\x02\x02w\u016A\x03\x02\x02\x02y\u0175\x03\x02\x02\x02{\u0188" +
		"\x03\x02\x02\x02}\u018A\x03\x02\x02\x02\x7F\u01A4\x03\x02\x02\x02\x81" +
		"\u01A6\x03\x02\x02\x02\x83\u01A8\x03\x02\x02\x02\x85\x86\x07p\x02\x02" +
		"\x86\x87\x07g\x02\x02\x87\x88\x07y\x02\x02\x88\x04\x03\x02\x02\x02\x89" +
		"\x8A\t\x02\x02\x02\x8A\x8B\x03\x02\x02\x02\x8B\x8C\b\x03\x02\x02\x8C\x06" +
		"\x03\x02\x02\x02\x8D\x8E\x07v\x02\x02\x8E\x8F\x07t\x02\x02\x8F\x90\x07" +
		"w\x02\x02\x90\x91\x07g\x02\x02\x91\b\x03\x02\x02\x02\x92\x93\x07h\x02" +
		"\x02\x93\x94\x07c\x02\x02\x94\x95\x07n\x02\x02\x95\x96\x07u\x02\x02\x96" +
		"\x97\x07g\x02\x02\x97\n\x03\x02\x02\x02\x98\x99\x07c\x02\x02\x99\x9A\x07" +
		"p\x02\x02\x9A\x9B\x07f\x02\x02\x9B\f\x03\x02\x02\x02\x9C\x9D\x07q\x02" +
		"\x02\x9D\x9E\x07t\x02\x02\x9E\x0E\x03\x02\x02\x02\x9F\xA0\x07z\x02\x02" +
		"\xA0\xA1\x07q\x02\x02\xA1\xA2\x07t\x02\x02\xA2\x10\x03\x02\x02\x02\xA3" +
		"\xA4\x07k\x02\x02\xA4\xA5\x07p\x02\x02\xA5\x12\x03\x02\x02\x02\xA6\xA7" +
		"\x07k\x02\x02\xA7\xA8\x07u\x02\x02\xA8\x14\x03\x02\x02\x02\xA9\xAA\x07" +
		"d\x02\x02\xAA\xAB\x07g\x02\x02\xAB\xAC\x07v\x02\x02\xAC\xAD\x07y\x02\x02" +
		"\xAD\xAE\x07g\x02\x02\xAE\xAF\x07g\x02\x02\xAF\xB0\x07p\x02\x02\xB0\x16" +
		"\x03\x02\x02\x02\xB1\xB2\x07n\x02\x02\xB2\xB3\x07k\x02\x02\xB3\xB4\x07" +
		"m\x02\x02\xB4\xB5\x07g\x02\x02\xB5\x18\x03\x02\x02\x02\xB6\xB7\x07o\x02" +
		"\x02\xB7\xB8\x07c\x02\x02\xB8\xB9\x07v\x02\x02\xB9\xBA\x07e\x02\x02\xBA" +
		"\xBB\x07j\x02\x02\xBB\xBC\x07g\x02\x02\xBC\xBD\x07u\x02\x02\xBD\x1A\x03" +
		"\x02\x02\x02\xBE\xBF\x07p\x02\x02\xBF\xC0\x07w\x02\x02\xC0\xC1\x07n\x02" +
		"\x02\xC1\xC2\x07n\x02\x02\xC2\x1C\x03\x02\x02\x02\xC3\xC4\x070\x02\x02" +
		"\xC4\x1E\x03\x02\x02\x02\xC5\xC6\x07B\x02\x02\xC6 \x03\x02\x02\x02\xC7" +
		"\xC8\x07b\x02\x02\xC8\"\x03\x02\x02\x02\xC9\xCA\x07^\x02\x02\xCA$\x03" +
		"\x02\x02\x02\xCB\xCC\x07~\x02\x02\xCC&\x03\x02\x02\x02\xCD\xCE\x07#\x02" +
		"\x02\xCE(\x03\x02\x02\x02\xCF\xD0\x07A\x02\x02\xD0*\x03\x02\x02\x02\xD1" +
		"\xD2\x07&\x02\x02\xD2,\x03\x02\x02\x02\xD3\xD4\x07%\x02\x02\xD4.\x03\x02" +
		"\x02\x02\xD5\xD6\x07*\x02\x02\xD60\x03\x02\x02\x02\xD7\xD8\x07+\x02\x02" +
		"\xD82\x03\x02\x02\x02\xD9\xDA\x07]\x02\x02\xDA4\x03\x02\x02\x02\xDB\xDC" +
		"\x07_\x02\x02\xDC6\x03\x02\x02\x02\xDD\xDE\x07}\x02\x02\xDE8\x03\x02\x02" +
		"\x02\xDF\xE0\x07\x7F\x02\x02\xE0:\x03\x02\x02\x02\xE1\xE2\x07.\x02\x02" +
		"\xE2<\x03\x02\x02\x02\xE3\xE4\x07=\x02\x02\xE4>\x03\x02\x02\x02\xE5\xE6" +
		"\x07<\x02\x02\xE6@\x03\x02\x02\x02\xE7\xE8\x07?\x02\x02\xE8B\x03\x02\x02" +
		"\x02\xE9\xEA\x07A\x02\x02\xEA\xEB\x07A\x02\x02\xEBD\x03\x02\x02\x02\xEC" +
		"\xED\x07-\x02\x02\xEDF\x03\x02\x02\x02\xEE\xEF\x07/\x02\x02\xEFH\x03\x02" +
		"\x02\x02\xF0\xF1\x071\x02\x02\xF1J\x03\x02\x02\x02\xF2\xF3\x07,\x02\x02" +
		"\xF3L\x03\x02\x02\x02\xF4\xF5\x07\'\x02\x02\xF5N\x03\x02\x02\x02\xF6\xF7" +
		"\x07`\x02\x02\xF7P\x03\x02\x02\x02\xF8\xF9\x07?\x02\x02\xF9\xFA\x07?\x02" +
		"\x02\xFAR\x03\x02\x02\x02\xFB\xFC\x07#\x02\x02\xFC\xFD\x07?\x02\x02\xFD" +
		"T\x03\x02\x02\x02\xFE\xFF\x07>\x02\x02\xFFV\x03\x02\x02\x02\u0100\u0101" +
		"\x07>\x02\x02\u0101\u0102\x07?\x02\x02\u0102X\x03\x02\x02\x02\u0103\u0104" +
		"\x07@\x02\x02\u0104Z\x03\x02\x02\x02\u0105\u0106\x07@\x02\x02\u0106\u0107" +
		"\x07?\x02\x02\u0107\\\x03\x02\x02\x02\u0108\u0109\x07#\x02\x02\u0109\u010A" +
		"\x07}\x02\x02\u010A^\x03\x02\x02\x02\u010B\u010C\x07A\x02\x02\u010C\u010D" +
		"\x07}\x02\x02\u010D`\x03\x02\x02\x02\u010E\u010F\x07`\x02\x02\u010F\u0110" +
		"\x07}\x02\x02\u0110b\x03\x02\x02\x02\u0111\u0112\x07&\x02\x02\u0112\u0113" +
		"\x07}\x02\x02\u0113d\x03\x02\x02\x02\u0114\u0115\x07V\x02\x02\u0115\u0116" +
		"\x07*\x02\x02\u0116f\x03\x02\x02\x02\u0117\u0118\x07}\x02\x02\u0118\u0119" +
		"\x07~\x02\x02\u0119h\x03\x02\x02\x02\u011A\u011B\x07^\x02\x02\u011B\u011C" +
		"\x070\x02\x02\u011Cj\x03\x02\x02\x02\u011D\u011E\x07)\x02\x02\u011El\x03" +
		"\x02\x02\x02\u011F\u0124\x05k6\x02\u0120\u0123\x05o8\x02\u0121\u0123\n" +
		"\x03\x02\x02\u0122\u0120\x03\x02\x02\x02\u0122\u0121\x03\x02\x02\x02\u0123" +
		"\u0126\x03\x02\x02\x02\u0124\u0122\x03\x02\x02\x02\u0124\u0125\x03\x02" +
		"\x02\x02\u0125\u0127\x03\x02\x02\x02\u0126\u0124\x03\x02\x02\x02\u0127" +
		"\u0128\x05k6\x02\u0128n\x03\x02\x02\x02\u0129\u012A\x05k6\x02\u012A\u012B" +
		"\x05k6\x02\u012Bp\x03\x02\x02\x02\u012C\u0130\t\x04\x02\x02\u012D\u012F" +
		"\t\x05\x02\x02\u012E\u012D\x03\x02\x02\x02\u012F\u0132\x03\x02\x02\x02" +
		"\u0130\u012E\x03\x02\x02\x02\u0130\u0131\x03\x02\x02\x02\u0131r\x03\x02" +
		"\x02\x02\u0132\u0130\x03\x02\x02\x02\u0133\u0135\x070\x02\x02\u0134\u0136" +
		"\x05y=\x02\u0135\u0134\x03\x02\x02\x02\u0136\u0137\x03\x02\x02\x02\u0137" +
		"\u0135\x03\x02\x02\x02\u0137\u0138\x03\x02\x02\x02\u0138\u013A\x03\x02" +
		"\x02\x02\u0139\u013B\x05\x7F@\x02\u013A\u0139\x03\x02\x02\x02\u013A\u013B" +
		"\x03\x02\x02\x02\u013B\u013D\x03\x02\x02\x02\u013C\u013E\x05\x83B\x02" +
		"\u013D\u013C\x03\x02\x02\x02\u013D\u013E\x03\x02\x02\x02\u013E\u0161\x03" +
		"\x02\x02\x02\u013F\u0141\x05y=\x02\u0140\u013F\x03\x02\x02\x02\u0141\u0142" +
		"\x03\x02\x02\x02\u0142\u0140\x03\x02\x02\x02\u0142\u0143\x03\x02\x02\x02" +
		"\u0143\u0144\x03\x02\x02\x02\u0144\u0146\x070\x02\x02\u0145\u0147\x05" +
		"y=\x02\u0146\u0145\x03\x02\x02\x02\u0147\u0148\x03\x02\x02\x02\u0148\u0146" +
		"\x03\x02\x02\x02\u0148\u0149\x03\x02\x02\x02\u0149\u014B\x03\x02\x02\x02" +
		"\u014A\u014C\x05\x7F@\x02\u014B\u014A\x03\x02\x02\x02\u014B\u014C\x03" +
		"\x02\x02\x02\u014C\u014E\x03\x02\x02\x02\u014D\u014F\x05\x83B\x02\u014E" +
		"\u014D\x03\x02\x02\x02\u014E\u014F\x03\x02\x02\x02\u014F\u0161\x03\x02" +
		"\x02\x02\u0150\u0152\x05y=\x02\u0151\u0150\x03\x02\x02\x02\u0152\u0153" +
		"\x03\x02\x02\x02\u0153\u0151\x03\x02\x02\x02\u0153\u0154\x03\x02\x02\x02" +
		"\u0154\u0155\x03\x02\x02\x02\u0155\u0157\x05\x7F@\x02\u0156\u0158\x05" +
		"\x83B\x02\u0157\u0156\x03\x02\x02\x02\u0157\u0158\x03\x02\x02\x02\u0158" +
		"\u0161\x03\x02\x02\x02\u0159\u015B\x05y=\x02\u015A\u0159\x03\x02\x02\x02" +
		"\u015B\u015C\x03\x02\x02\x02\u015C\u015A\x03\x02\x02\x02\u015C\u015D\x03" +
		"\x02\x02\x02\u015D\u015E\x03\x02\x02\x02\u015E\u015F\x05\x83B\x02\u015F" +
		"\u0161\x03\x02\x02\x02\u0160\u0133\x03\x02\x02\x02\u0160\u0140\x03\x02" +
		"\x02\x02\u0160\u0151\x03\x02\x02\x02\u0160\u015A\x03\x02\x02\x02\u0161" +
		"t\x03\x02\x02\x02\u0162\u0164\x05y=\x02\u0163\u0162\x03\x02\x02\x02\u0164" +
		"\u0165\x03\x02\x02\x02\u0165\u0163\x03\x02\x02\x02\u0165\u0166\x03\x02" +
		"\x02\x02\u0166\u0168\x03\x02\x02\x02\u0167\u0169\x05{>\x02\u0168\u0167" +
		"\x03\x02\x02\x02\u0168\u0169\x03\x02\x02\x02\u0169v\x03\x02\x02\x02\u016A" +
		"\u016B\x072\x02\x02\u016B\u016C\x07z\x02\x02\u016C\u016E\x03\x02\x02\x02" +
		"\u016D\u016F\x05}?\x02\u016E\u016D\x03\x02\x02\x02\u016F\u0170\x03\x02" +
		"\x02\x02\u0170\u016E\x03\x02\x02\x02\u0170\u0171\x03\x02\x02\x02\u0171" +
		"\u0173\x03\x02\x02\x02\u0172\u0174\x05{>\x02\u0173\u0172\x03\x02\x02\x02" +
		"\u0173\u0174\x03\x02\x02\x02\u0174x\x03\x02\x02\x02\u0175\u0176\x042;" +
		"\x02\u0176z\x03\x02\x02\x02\u0177\u0178\x07W\x02\x02\u0178\u0189\x07N" +
		"\x02\x02\u0179\u017A\x07N\x02\x02\u017A\u0189\x07W\x02\x02\u017B\u017C" +
		"\x07w\x02\x02\u017C\u0189\x07n\x02\x02\u017D\u017E\x07n\x02\x02\u017E" +
		"\u0189\x07w\x02\x02\u017F\u0180\x07W\x02\x02\u0180\u0189\x07N\x02\x02" +
		"\u0181\u0182\x07N\x02\x02\u0182\u0189\x07W\x02\x02\u0183\u0184\x07w\x02" +
		"\x02\u0184\u0189\x07N\x02\x02\u0185\u0186\x07n\x02\x02\u0186\u0189\x07" +
		"W\x02\x02\u0187\u0189\t\x06\x02\x02\u0188\u0177\x03\x02\x02\x02\u0188" +
		"\u0179\x03\x02\x02\x02\u0188\u017B\x03\x02\x02\x02\u0188\u017D\x03\x02" +
		"\x02\x02\u0188\u017F\x03\x02\x02\x02\u0188\u0181\x03\x02\x02\x02\u0188" +
		"\u0183\x03\x02\x02\x02\u0188\u0185\x03\x02\x02\x02\u0188\u0187\x03\x02" +
		"\x02\x02\u0189|\x03\x02\x02\x02\u018A\u018B\t\x07\x02\x02\u018B~\x03\x02" +
		"\x02\x02\u018C\u0190\x07g\x02\x02\u018D\u018F\x05\x81A\x02\u018E\u018D" +
		"\x03\x02\x02\x02\u018F\u0192\x03\x02\x02\x02\u0190\u018E\x03\x02\x02\x02" +
		"\u0190\u0191\x03\x02\x02\x02\u0191\u0194\x03\x02\x02\x02\u0192\u0190\x03" +
		"\x02\x02\x02\u0193\u0195\x05y=\x02\u0194\u0193\x03\x02\x02\x02\u0195\u0196" +
		"\x03\x02\x02\x02\u0196\u0194\x03\x02\x02\x02\u0196\u0197\x03\x02\x02\x02" +
		"\u0197\u01A5\x03\x02\x02\x02\u0198\u019C\x07G\x02\x02\u0199\u019B\x05" +
		"\x81A\x02\u019A\u0199\x03\x02\x02\x02\u019B\u019E\x03\x02\x02\x02\u019C" +
		"\u019A\x03\x02\x02\x02\u019C\u019D\x03\x02\x02\x02\u019D\u01A0\x03\x02" +
		"\x02\x02\u019E\u019C\x03\x02\x02\x02\u019F\u01A1\x05y=\x02\u01A0\u019F" +
		"\x03\x02\x02\x02\u01A1\u01A2\x03\x02\x02\x02\u01A2\u01A0\x03\x02\x02\x02" +
		"\u01A2\u01A3\x03\x02\x02\x02\u01A3\u01A5\x03\x02\x02\x02\u01A4\u018C\x03" +
		"\x02\x02\x02\u01A4\u0198\x03\x02\x02\x02\u01A5\x80\x03\x02\x02\x02\u01A6" +
		"\u01A7\t\b\x02\x02\u01A7\x82\x03\x02\x02\x02\u01A8\u01A9\t\t\x02\x02\u01A9" +
		"\x84\x03\x02\x02\x02\x1B\x02\u0122\u0124\u0130\u0137\u013A\u013D\u0142" +
		"\u0148\u014B\u014E\u0153\u0157\u015C\u0160\u0165\u0168\u0170\u0173\u0188" +
		"\u0190\u0196\u019C\u01A2\u01A4\x03\b\x02\x02";
	public static __ATN: ATN;
	public static get _ATN(): ATN {
		if (!ExpressionLexer.__ATN) {
			ExpressionLexer.__ATN = new ATNDeserializer().deserialize(Utils.toCharArray(ExpressionLexer._serializedATN));
		}

		return ExpressionLexer.__ATN;
	}

}

